import _extends from "babel-runtime/helpers/extends";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
/**
 * Author:  liu.yang
 * Date: 2018-05-17 09:42:35
 */
import React, { Component } from "react";
import { Layout } from "antd";
import p from "solomon-class-prefix";
import { findActiveArray } from "solomon-utils";

import TopHeader from "kim-header";

import BaseMenu from "./BaseMenu";
// import menuData from "./menuData";

import "./style.less";

var Content = Layout.Content;


var CLS_PREFIX = "solomon-layout-base";
var addPrefix = p(CLS_PREFIX);

var BaseLayout = function (_Component) {
  _inherits(BaseLayout, _Component);

  function BaseLayout() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, BaseLayout);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BaseLayout.__proto__ || Object.getPrototypeOf(BaseLayout)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      collapsed: false
    }, _this.onCollapse = function () {
      var collapsed = _this.state.collapsed;

      _this.setState({ collapsed: !collapsed });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(BaseLayout, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          children = _props.children,
          menuData = _props.menuData,
          _props$menuOptions = _props.menuOptions,
          menuOptions = _props$menuOptions === undefined ? {} : _props$menuOptions,
          headerOptions = _props.headerOptions,
          className = _props.className;
      var collapsed = this.state.collapsed;
      var selectedkey = menuOptions.selectedkey,
          _menuOptions$fixed = menuOptions.fixed,
          fixedLiftMenu = _menuOptions$fixed === undefined ? false : _menuOptions$fixed,
          _menuOptions$width = menuOptions.width,
          width = _menuOptions$width === undefined ? 256 : _menuOptions$width,
          _menuOptions$miniWidt = menuOptions.miniWidth,
          miniWidth = _menuOptions$miniWidt === undefined ? 80 : _menuOptions$miniWidt;


      var newMenuOptions = {
        collapsed: collapsed,
        menuData: menuData,
        menuOptions: menuOptions
      };
      var newHeaderOptions = _extends({
        menuData: menuData,
        menuOptions: menuOptions
      }, headerOptions);

      if (selectedkey) {
        var activeMenus = findActiveArray(selectedkey, menuData);
        newHeaderOptions.breadcrumbData = activeMenus;
        newMenuOptions.menuOptions.defaultOpenKeys = activeMenus.map(function (item) {
          return item.key;
        });
      }
      // const childrenProps = { ...this.props };
      // delete childrenProps.children;

      var _newHeaderOptions$fix = newHeaderOptions.fixed,
          fixedHeader = _newHeaderOptions$fix === undefined ? false : _newHeaderOptions$fix,
          _newHeaderOptions$hea = newHeaderOptions.headerHeight,
          headerHeight = _newHeaderOptions$hea === undefined ? 64 + 54 : _newHeaderOptions$hea;


      var fixedContentStyles = {
        paddingTop: headerHeight + "px"
      };

      if (fixedLiftMenu) {
        fixedContentStyles.paddingLeft = width + "px";
      }
      if (collapsed) {
        fixedContentStyles.paddingLeft = miniWidth + "px";
      }
      return React.createElement(
        Layout,
        {
          className: addPrefix("wrap") + " " + (className && className) + " ant-layout-has-sider"
        },
        React.createElement(BaseMenu, newMenuOptions),
        React.createElement(
          Layout,
          { id: "solomon-container" },
          React.createElement(TopHeader, _extends({
            collapsed: collapsed,
            onCollapse: this.onCollapse
          }, newHeaderOptions)),
          React.createElement(
            Content,
            {
              className: addPrefix("content"),
              style: fixedHeader ? fixedContentStyles : null
            },
            children
          )
        )
      );
    }
  }]);

  return BaseLayout;
}(Component);

export default BaseLayout;